bridge-utils: /etc/network/if-pre-up.d/bridge doesn't handle multiple stanzas of bridge_portprio

Bug #1576876 reported by Ryan Harper on 2016-04-29
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
bridge-utils (Ubuntu)
Medium
Unassigned

Bug Description

1. % lsb_release -rd
Description: Ubuntu 16.04 LTS
Release: 16.04

2. % apt-cache policy bridge-utils
bridge-utils:
  Installed: 1.5-9ubuntu1
  Candidate: 1.5-9ubuntu1
  Version table:
 *** 1.5-9ubuntu1 500
        500 http://us.archive.ubuntu.com/ubuntu xenial/main amd64 Packages
        100 /var/lib/dpkg/status

3. with a bridge stanza like this:

auto br0
iface br0 inet static
    address 192.168.14.2/24
    bridge_ports eth1 eth2
    bridge_portprio eth1 28
    bridge_portprio eth2 16

After ifup br0, /sys/class/net/br0/brif/eth2/priority should be 16.

4.

/etc/network/if-pre-up.d/bridge executes:

brctl setportprio br0 eth1 28 eth2 16

which succeeds in setting eth1 to 28, but does not apply a setting to eth2

Instead, we need to iterate over the ports (in case there is more than one port per bridge)

# diff -u bridge.orig bridge
--- bridge.orig 2016-04-29 21:52:34.785204215 +0000
+++ bridge 2016-04-29 21:51:47.237066594 +0000
@@ -134,7 +134,11 @@

   if [ "$IF_BRIDGE_PORTPRIO" ]
   then
- brctl setportprio $IFACE $IF_BRIDGE_PORTPRIO
+ echo "$IF_BRIDGE_PORTPRIO" | {
+ while read PORT PRIO; do
+ brctl setportprio $IFACE $PORT $PRIO
+ done
+ }
   fi

   if [ "$IF_BRIDGE_STP" ]

ProblemType: Bug
DistroRelease: Ubuntu 16.04
Package: bridge-utils 1.5-9ubuntu1
ProcVersionSignature: Ubuntu 4.4.0-21.37-generic 4.4.6
Uname: Linux 4.4.0-21-generic x86_64
NonfreeKernelModules: zfs zunicode zcommon znvpair zavl
ApportVersion: 2.20.1-0ubuntu2
Architecture: amd64
CurrentDesktop: GNOME-Flashback:GNOME
Date: Fri Apr 29 16:45:30 2016
Dependencies:
 gcc-6-base 6.0.1-0ubuntu1
 libc6 2.23-0ubuntu3
 libgcc1 1:6.0.1-0ubuntu1
InstallationDate: Installed on 2016-01-01 (119 days ago)
InstallationMedia: Ubuntu 16.04 LTS "Xenial Xerus" - Alpha amd64 (20151209)
SourcePackage: bridge-utils
UpgradeStatus: No upgrade log present (probably fresh install)

Ryan Harper (raharper) wrote :
Changed in bridge-utils (Ubuntu):
status: New → In Progress
importance: Undecided → Medium
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package bridge-utils - 1.5-9ubuntu2

---------------
bridge-utils (1.5-9ubuntu2) yakkety; urgency=medium

  * debian/ifupdown.sh:
    - Handle bridge params which use port and value (LP: #1576876)
  * debian/bridge-utils-interface.5:
    - Update max, default value for path cost (LP: #1576870)
    - Update unsettable gcint value for newer kernels (LP: #1576858)

 -- Ryan Harper <email address hidden> Thu, 05 May 2016 10:38:12 -0500

Changed in bridge-utils (Ubuntu):
status: In Progress → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers